
*INIT MEMORY MACRO
*USES: AR0, AR1, AC
*
*      INIT <ITEM-LIST>
*      <ITEM-LIST>:=<ITEM>|<ITEM>,<ITEM-LIST>
*      <ITEM>:=(<CONST>,VAR)
*      VAR IS A SYMBOLIC MEMORY LOCATION TO INITIALIZED
*      <CONST>:=VALUE|(VALUE,VALUE,VALUE, ... ,VALUE)
*      VALUE IS AN ASSY TIME CONSTANT

INIT   $MACRO            A1,A2,A3,A4,A5,A6,A7,A8
       CALL   INIT$      CALL INIT SUBR
       REF    INIT$
       $IF    A1.L#=0
       $INIT3 :A1:
       $ENDIF
       $IF    A2.L#=0
       $INIT3 :A2:
       $ENDIF
       $IF    A3.L#=0
       $INIT3 :A3:
       $ENDIF
       $IF    A4.L#=0
       $INIT3 :A4:
       $ENDIF
       $IF    A5.L#=0
       $INIT3 :A5:
       $ENDIF
       $IF    A6.L#=0
       $INIT3 :A6:
       $ENDIF
       $IF    A7.L#=0
       $INIT3 :A7:
       $ENDIF
       $IF    A8.L#=0
       $INIT2 :A8:
       $ENDIF
       DATA -1           END OF INIT LIST
       $END

$INIT2 $MACRO            A,B
       $INIT3            :A:  DO AN ITEM
       $IF  B.L#=0
       $INIT2            :B:  RECURSE
       $ENDIF
       $END

$INIT3 $MACRO            A,B
       $IF  A.A&$POPL    VALUE LIST
       DATA :A.V:        FOR :A.V: WORDS
       $ELSE
       DATA 1            FOR ONE WORD
       $ENDIF
       DATA :B:          TO :B:
       DATA :A:          DATA LIST
       $END